#include <windows.h>
typedef unsigned long DWORD_PTR;
typedef long LONG_PTR;
#include <dshow.h>
#include "BaseClasses/streams.h"
#include <initguid.h>
#include <qnetwork.h>
#include <time.h>

#include "intdef.h"
#include "PowerWildCard.h"
#include "CommandLine.h"


#include "Gargle/gargle.h"
bool otdeta = false;


CommandLineString _cmdline;

HINSTANCE hInst;

LRESULT CALLBACK WndProc(HWND,UINT,WPARAM,LPARAM);

HWND hwMain;

HWND hwndText1;
HWND hwndText2;
HWND hwndText3;
HWND hwndButton;
int fontsize;

IVideoWindow *pVideoWindow = NULL;
bool audio = false;
bool video = false;
long videw, videh;
IBasicAudio *pBasicAudio = NULL;
bool yjmute = false;
bool omcisak = false;
HFONT hFont, hMuFont;
HWND globalhwnd = NULL;

int WINAPI WinMain(HINSTANCE hInstance,HINSTANCE hPrevInstance,
                    PSTR szCmdLine,int iCmdShow){

	MSG  msg;
	WNDCLASSEX wndclass;
	LOGFONT lofo;
	int i;
	long oab;

	_cmdline.set(GetCommandLine());
	if(_cmdline.count() < 2) return 0;
	oab = 0;
	for(i=0; i < _cmdline.get()[1].GetLength(); i++) oab += _cmdline.get()[_cmdline.count()-1].GetConst()[i];
	srand(oab+(unsigned)time(NULL));


	SystemParametersInfo(SPI_GETICONTITLELOGFONT, sizeof(LOGFONT), &lofo, 0);
	fontsize = lofo.lfHeight<0?-lofo.lfHeight:lofo.lfHeight;
	// EChENXݒ
	wndclass.cbSize        = sizeof(wndclass);
	wndclass.style         = CS_HREDRAW | CS_VREDRAW;
	wndclass.lpfnWndProc   = WndProc;
	wndclass.cbClsExtra    = 0;
	wndclass.cbWndExtra    = 0;
	wndclass.hInstance     = hInstance;
	wndclass.hIcon         = LoadIcon(GetModuleHandle(NULL), _T("BPIcon"));;
	wndclass.hCursor       = LoadCursor(NULL,IDC_ARROW);
	wndclass.hbrBackground = (HBRUSH)GetStockObject(DKGRAY_BRUSH);
	wndclass.lpszMenuName  = NULL;
	wndclass.lpszClassName = _T("CWindow");
	wndclass.hIconSm       = NULL;

	RegisterClassEx(&wndclass); /* EChENXo^ */

	globalhwnd = CreateWindow(_T("CWindow"),_T("傫ĉt"),
	  WS_OVERLAPPEDWINDOW | WS_VISIBLE|WS_CLIPCHILDREN|WS_VSCROLL,CW_USEDEFAULT,CW_USEDEFAULT,
	  280,120,NULL,NULL,hInstance,NULL);


	while (GetMessage(&msg,NULL,0,0)) { /* bZ[W[v */

		switch(msg.message){
		case WM_RBUTTONUP:
			if(msg.hwnd == hwndButton){
				yjmute = !yjmute;
				pBasicAudio->put_Volume(yjmute?-10000:0);
				SendMessage(hwndButton, WM_SETFONT, (WPARAM)(yjmute ? hMuFont : hFont), FALSE);
				InvalidateRect(hwndButton, NULL, TRUE);
				UpdateWindow(hwndButton);
				continue;
			}
			break;
		}

		TranslateMessage(&msg);
		DispatchMessage(&msg);

	}

	return msg.wParam;

}

void ReSiZer(const unsigned short wi, const unsigned short hi)
{
	double w, h;
	int omasix, omasiy;
	if(video){
		w = (double)wi / (double)videw;
		h = (double)(hi-3*fontsize) / (double)videh;
		if(w > h){
			omasix = (int)(h*(double)videw+0.5);
			omasiy = hi-3*fontsize;
			pVideoWindow->SetWindowPosition((wi-omasix)/2,0,omasix,omasiy);
		}else{
			omasix = wi;
			omasiy = (int)(w*(double)videh+0.5);
			pVideoWindow->SetWindowPosition(0,(hi-3*fontsize-omasiy)/2,omasix,omasiy);
		}
	}
	MoveWindow(hwndText1, 0, video ? hi-3*fontsize : 0, wi, video ? 2*fontsize : hi-fontsize, FALSE);
	MoveWindow(hwndText2, 0, hi - fontsize, wi/3, fontsize, FALSE);
	MoveWindow(hwndText3, 2*(wi/3), hi - fontsize, wi - 2*(wi/3), fontsize, FALSE);
	MoveWindow(hwndButton, wi/3, hi - fontsize, wi/3, fontsize, TRUE);
}

RECT rectest;
BOOL CALLBACK EnumWindowsProc(
  HWND hwnd,      // eEBhẼnh
  LPARAM lParam   // AvP[V`̒l
)
{
	RECT rect;
	if(IsWindowVisible(hwnd) == 0 || hwnd == globalhwnd || !GetWindowRect(hwnd, &rect)) return TRUE;
	if(rect.left > rectest.left){
		if(rect.left > rectest.right) return TRUE;
		if(rect.top > rectest.top){
			if(rect.top > rectest.bottom) return TRUE;
			*(int *)lParam += ((rect.right<rectest.right?rect.right:rectest.right)-rect.left)*((rect.bottom<rectest.bottom?rect.bottom:rectest.bottom)-rect.top);
		}else{
			if(rect.bottom < rectest.top) return TRUE;
			*(int *)lParam += ((rect.right<rectest.right?rect.right:rectest.right)-rect.left)*((rect.bottom<rectest.bottom?rect.bottom:rectest.bottom)-rectest.top);
		}
	}else{
		if(rect.right < rectest.left) return TRUE;
		if(rect.top > rectest.top){
			if(rect.top > rectest.bottom) return TRUE;
			*(int *)lParam += ((rect.right<rectest.right?rect.right:rectest.right)-rectest.left)*((rect.bottom<rectest.bottom?rect.bottom:rectest.bottom)-rect.top);
		}else{
			if(rect.bottom < rectest.top) return TRUE;
			*(int *)lParam += ((rect.right<rectest.right?rect.right:rectest.right)-rectest.left)*((rect.bottom<rectest.bottom?rect.bottom:rectest.bottom)-rectest.top);
		}
	}
	return TRUE;
}
LRESULT CALLBACK WndProc(HWND hwnd, UINT iMsg, WPARAM wParam, LPARAM lParam)
{
	const int totime = 150;
	const int motime = 10;
	static HINSTANCE r;

	static IGraphBuilder *pGraphBuilder = NULL;
	static IMediaControl *pMediaControl = NULL;
	static IMediaEventEx *pMediaEventEx = NULL;
	static IMediaPosition *pMediaPosition = NULL;
	static IBasicVideo *pBasicVideo = NULL;
	static IBaseFilter *pGargle = NULL;
	static bool play = false;
	static REFTIME length, lll, olll = 0;
	static SCROLLINFO scr;
	static PWCArray<_TCHAR> tmps;
	static int tout = totime;
	static int mout = 0;
	static RECT recting, orectn, ooorectn;
	IEnumFilters *pEnumFilters;
	IBaseFilter *pBaseFilter;
	IAMMediaContent *pAMMediaContent;
	BSTR bst;
	RECT recter, recnar;
	CGargle *p;
	HRESULT hr;
	WINDOWPLACEMENT ments;
	int i, j, k, l, m, n, o, iiiii, iiiiiii;
	long eventCode, p1, p2;
	int omasix, omasiy;
	double w, h;
	REFTIME ttl, ttt;

	switch (iMsg) {

	case WM_CREATE:

		hwMain = hwnd;
		hwndText1 = CreateWindow(_T("EDIT"), _T(""), WS_CHILD|WS_VISIBLE|WS_VSCROLL|ES_MULTILINE|ES_READONLY, 0, 0, 0, 0,
			hwnd, (HMENU)1, GetModuleHandle(NULL), NULL);
		hwndText2 = CreateWindow(_T("EDIT"), _T(""), WS_CHILD|WS_VISIBLE|ES_READONLY|ES_CENTER, 0, 0, 0, 0,
			hwnd, (HMENU)2, GetModuleHandle(NULL), NULL);
		hwndText3 = CreateWindow(_T("EDIT"), _T(""), WS_CHILD|WS_VISIBLE|ES_READONLY|ES_RIGHT, 0, 0, 0, 0,
			hwnd, (HMENU)3, GetModuleHandle(NULL), NULL);
		hwndButton = CreateWindow(_T("BUTTON"), _T(""), WS_CHILD|WS_VISIBLE|BS_PUSHBUTTON|BS_FLAT, 0, 0, 0, 0,
			hwnd, (HMENU)5, GetModuleHandle(NULL), NULL);
		hFont = CreateFont(fontsize,0,0,0,
			FW_DONTCARE,FALSE,FALSE,FALSE,DEFAULT_CHARSET,
			OUT_CHARACTER_PRECIS,
			CLIP_DEFAULT_PRECIS,DEFAULT_QUALITY,
			FF_DONTCARE | DEFAULT_PITCH,
			_T(""));
		hMuFont = CreateFont(fontsize/2,0,0,0,
			FW_DONTCARE,FALSE,FALSE,FALSE,DEFAULT_CHARSET,
			OUT_CHARACTER_PRECIS,
			CLIP_DEFAULT_PRECIS,DEFAULT_QUALITY,
			FF_DONTCARE | DEFAULT_PITCH,
			_T(""));
		SendMessage(hwndText1, WM_SETFONT, (WPARAM)hFont, FALSE);
		SendMessage(hwndText2, WM_SETFONT, (WPARAM)hFont, FALSE);
		SendMessage(hwndText3, WM_SETFONT, (WPARAM)hFont, FALSE);
		SendMessage(hwndButton, WM_SETFONT, (WPARAM)hFont, FALSE);
		scr.cbSize = sizeof(SCROLLINFO);
		scr.fMask = SIF_PAGE | SIF_POS | SIF_RANGE | SIF_DISABLENOSCROLL;
		scr.nMin = 0;
		scr.nMax = USHRT_MAX;
		scr.nPage = 1;
		scr.nPos = 0;
		SetScrollInfo(hwnd , SB_VERT , &scr , TRUE);

		tmps = _cmdline.get()[_cmdline.count()-1].GetConst();
		SetWindowText(hwndText1, _cmdline.get()[_cmdline.count()-1].GetConst());
		tmps = _cmdline.get()[_cmdline.count()-1].GetConst();
		tmps += _T('\0');
		j = 0;
		for(i=0; tmps[i] != _T('\0'); i++) if(tmps[i] == _T('\\')) j = i+1;
		SetWindowText(hwnd, tmps.GetData()+j);

		CoInitialize(NULL);

		CoCreateInstance(CLSID_FilterGraph,
			NULL,
			CLSCTX_INPROC_SERVER,
			IID_IGraphBuilder,
			(LPVOID *)&pGraphBuilder);

		pGraphBuilder->QueryInterface(IID_IMediaControl,
			(LPVOID *)&pMediaControl);

		pGraphBuilder->QueryInterface(IID_IMediaEventEx,
			(LPVOID *)&pMediaEventEx);
		pMediaEventEx->SetNotifyWindow((OAHWND)hwnd,
			WM_USER, NULL);

		pGraphBuilder->QueryInterface(IID_IMediaPosition,
			(LPVOID *)&pMediaPosition);

		p = (CGargle *)CGargle::CreateInstance(NULL, &hr);
		p->QueryInterface(IID_IBaseFilter, (LPVOID *)&pGargle);
		pGraphBuilder->AddFilter(pGargle, _T("Gargle"));

		if(FAILED(pMediaControl->RenderFile(tmps.GetData()))){
			PostMessage(hwnd, WM_CLOSE, 0, 0);
			return 0;
		}

		pGraphBuilder->EnumFilters(&pEnumFilters);
		tmps.Clear();
		while(pEnumFilters->Next(1, &pBaseFilter, NULL) == S_OK){
			if(SUCCEEDED(pBaseFilter->QueryInterface(IID_IAMMediaContent, (LPVOID *)&pAMMediaContent))){
				if(SUCCEEDED(pAMMediaContent->get_AuthorName(&bst))){
					tmps += _T("AuthorName:");
					tmps += bst;
					tmps += _T("\r\n");
					SysFreeString(bst);
				}
				if(SUCCEEDED(pAMMediaContent->get_Title(&bst))){
					tmps += _T("Title:");
					i = tmps.GetLength();
					tmps += bst;
					if(tmps.GetLength() > i) SetWindowText(hwnd, bst);
					tmps += _T("\r\n");
					SysFreeString(bst);
				}
				if(SUCCEEDED(pAMMediaContent->get_Rating(&bst))){
					tmps += _T("Rating:");
					tmps += bst;
					tmps += _T("\r\n");
					SysFreeString(bst);
				}
				if(SUCCEEDED(pAMMediaContent->get_Description(&bst))){
					tmps += _T("Description:");
					tmps += bst;
					tmps += _T("\r\n");
					SysFreeString(bst);
				}
				if(SUCCEEDED(pAMMediaContent->get_Copyright(&bst))){
					tmps += _T("Copyright:");
					tmps += bst;
					tmps += _T("\r\n");
					SysFreeString(bst);
				}
				if(SUCCEEDED(pAMMediaContent->get_BaseURL(&bst))){
					tmps += _T("BaseURL:");
					tmps += bst;
					tmps += _T("\r\n");
					SysFreeString(bst);
				}
				if(SUCCEEDED(pAMMediaContent->get_LogoURL(&bst))){
					tmps += _T("LogoURL:");
					tmps += bst;
					tmps += _T("\r\n");
					SysFreeString(bst);
				}
				if(SUCCEEDED(pAMMediaContent->get_LogoIconURL(&bst))){
					tmps += _T("LogoIconURL:");
					tmps += bst;
					tmps += _T("\r\n");
					SysFreeString(bst);
				}
				if(SUCCEEDED(pAMMediaContent->get_WatermarkURL(&bst))){
					tmps += _T("WatermarkURL:");
					tmps += bst;
					tmps += _T("\r\n");
					SysFreeString(bst);
				}
				if(SUCCEEDED(pAMMediaContent->get_MoreInfoURL(&bst))){
					tmps += _T("MoreInfoURL:");
					tmps += bst;
					tmps += _T("\r\n");
					SysFreeString(bst);
				}
				if(SUCCEEDED(pAMMediaContent->get_MoreInfoBannerImage(&bst))){
					tmps += _T("MoreInfoBannerImage:");
					tmps += bst;
					tmps += _T("\r\n");
					SysFreeString(bst);
				}
				if(SUCCEEDED(pAMMediaContent->get_MoreInfoBannerURL(&bst))){
					tmps += _T("MoreInfoBannerURL:");
					tmps += bst;
					tmps += _T("\r\n");
					SysFreeString(bst);
				}
				if(SUCCEEDED(pAMMediaContent->get_MoreInfoText(&bst))){
					tmps += _T("MoreInfoText:");
					tmps += bst;
					tmps += _T("\r\n");
					SysFreeString(bst);
				}
				pAMMediaContent->Release();
			}
			pBaseFilter->Release();
		}
		pEnumFilters->Release();
		tmps += _T("FilePath:");
		tmps += _cmdline.get()[_cmdline.count()-1].GetConst();
		tmps += _T('\0');
		SetWindowText(hwndText1, tmps.GetData());

		pGraphBuilder->QueryInterface(IID_IBasicAudio,
			(LPVOID *)&pBasicAudio);
		audio = SUCCEEDED(pBasicAudio->get_Volume(&p1));

		pGraphBuilder->QueryInterface(IID_IBasicVideo,
			(LPVOID *)&pBasicVideo);
		videw = videh = 0;
		pBasicVideo->get_VideoHeight(&videh);
		pBasicVideo->get_VideoWidth(&videw);

		SystemParametersInfo(SPI_GETWORKAREA, 0, &recter, 0);
		k = 0;
		m = INT_MAX;
		i = (videw>280?videw:280)+2*GetSystemMetrics(SM_CXSIZEFRAME)+GetSystemMetrics(SM_CXVSCROLL);
		j = videh+3*fontsize+2*GetSystemMetrics(SM_CYSIZEFRAME)+GetSystemMetrics(SM_CYCAPTION);
		do{
			rectest.left = (i > recter.right-recter.left ? 0 : recter.left + rand()%(recter.right-recter.left-i));
			rectest.top = (j > recter.bottom-recter.top ? 0 : recter.top + rand()%(recter.bottom-recter.top-j));
			rectest.right = rectest.left + i;
			rectest.bottom = rectest.top + j;
			l = 0;
			EnumDesktopWindows(GetThreadDesktop(GetCurrentThreadId()), EnumWindowsProc, (LPARAM)&l);
			if(l < m){
				recting = rectest;
				m = l;
			}
		}while(++k < 100 && m > 0);
		pGraphBuilder->QueryInterface(IID_IVideoWindow,
			(LPVOID *)&pVideoWindow);
		// RenderFile()OƎs܂
		if(videw > 0){
			video = true;
			pVideoWindow->put_Owner((OAHWND)hwnd);
			pVideoWindow->put_MessageDrain((OAHWND)hwnd);
			pVideoWindow->put_WindowStyle(WS_CHILD|WS_CLIPSIBLINGS);
			pVideoWindow->put_AutoShow(OAFALSE);
		}
		MoveWindow(hwnd, recting.left, recting.top, recting.right-recting.left, recting.bottom-recting.top, TRUE);
		ooorectn = orectn = recting;

		for(i = 1; i < _cmdline.count()-1; i++){
			if(_cmdline.get()[i].GetLength() > 2 && _cmdline.get()[i].GetConst()[0] == _T('-')){
				if(_cmdline.get()[i].GetConst()[1] == _T('m')){
					yjmute = true;
					SendMessage(hwndButton, WM_SETFONT, (WPARAM)hMuFont, FALSE);
					pBasicAudio->put_Volume(-10000);
				}else if(_cmdline.get()[i].GetConst()[1] == _T('s')){
					omcisak = true;
					orectn.left += (videw>280?videw:280)/3;
					orectn.right -= (videw>280?videw:280)/3;
					orectn.top += videh/3;
					orectn.bottom -= videh/3;
					if(orectn.right > recter.right+recter.left){
						j = orectn.right - (recter.right+recter.left);
						orectn.left -= j;
						orectn.right -= j;
					}
					if(orectn.bottom > recter.bottom+recter.top){
						j = orectn.bottom - (recter.bottom+recter.top);
						orectn.top -= j;
						orectn.bottom -= j;
					}
					MoveWindow(hwnd, orectn.left, orectn.top, orectn.right-orectn.left, orectn.bottom-orectn.top, TRUE);
					rectest = recting = orectn;
				}else if(_cmdline.get()[i].GetConst()[1] == _T('t') && i+1 < _cmdline.count()){
					i++;
					SetWindowText(hwnd, _cmdline.get()[i].GetConst());
				}
			}
		}

		if(video){
			pVideoWindow->put_Visible(OATRUE);
		}
		if(orectn.right-orectn.left > recter.right-recter.left || orectn.bottom-orectn.top > recter.bottom-recter.top){
			pVideoWindow->put_FullScreenMode(OATRUE);
		}

		pMediaPosition->get_Duration(&length);
		tmps.Clear();
		ttl = (length+.005) / 3600;
		if(ttl >= 1){
			i = 0;
			ttt = ttl;
			while(true){
				ttt /= 10;
				if(ttt < 1.) break;
				i++;
			}
			ttt = 1;
			for(j=0; j < i; j++) ttt *= 10;
			for(; i >= 0; i--){
				tmps += _T('0') + (int)(ttl/ttt)%10;
				ttt /= 10;
			}
			tmps += _T(':');
		}
		ttl = (length+.005) / 60;
		tmps += _T('0') + (int)(ttl/10)%6;
		tmps += _T('0') + (int)ttl%10;
		tmps += _T(':');
		tmps += _T('0') + (int)((length+.005)/10)%6;
		tmps += _T('0') + (int)(length+.005)%10;
		tmps += _T('.');
		tmps += _T('0') + (int)(10*(length+.005))%10;
		tmps += _T('0') + (int)(100*(length+.005))%10;
		tmps += _T('\0');
		SetWindowText(hwndText2, tmps.GetData());

		pMediaControl->Run();
		play = true;
		SetWindowText(hwndButton, _T("a"));
		SetTimer(hwnd, 1, 100, NULL);

		return 0;

	case WM_TIMER:
		pMediaPosition->get_CurrentPosition(&lll);
		if(play){
			if((lll == olll) || (audio && !otdeta)){
				if(--tout <= 0){
					PostMessage(hwnd, WM_CLOSE, 0, 0);
					return 0;
				}
			}else{
				olll = lll;
				tout = totime;
				otdeta = false;
			}
		}
		scr.nPos = (int)((lll/length) * USHRT_MAX);
		SetScrollInfo(hwnd , SB_VERT , &scr , TRUE);
		tmps.Clear();
		ttl = lll / 3600;
		if(ttl >= 1){
			i = 0;
			ttt = ttl;
			while(true){
				ttt /= 10;
				if(ttt < 1.) break;
				i++;
			}
			ttt = 1;
			for(j=0; j < i; j++) ttt *= 10;
			for(; i >= 0; i--){
				tmps += _T('0') + (int)(ttl/ttt)%10;
				ttt /= 10;
			}
			tmps += _T(':');
		}
		ttl = lll / 60;
		tmps += _T('0') + (int)(ttl/10)%6;
		tmps += _T('0') + (int)ttl%10;
		tmps += _T(':');
		tmps += _T('0') + (int)(lll/10)%6;
		tmps += _T('0') + (int)lll%10;
		tmps += _T('.');
		tmps += _T('0') + (int)(10*lll)%10;
		tmps += _T('\0');
		SetWindowText(hwndText3, tmps.GetData());
		if(IsWindowVisible(hwnd) != 0
			&& (ments.length = sizeof(ments), GetWindowPlacement(hwnd, &ments))
			&& ments.showCmd != SW_SHOWMINIMIZED && ments.showCmd != SW_SHOWMAXIMIZED
			&& ments.showCmd != SW_MAXIMIZE && ments.showCmd != SW_MINIMIZE
			&& ments.showCmd != SW_FORCEMINIMIZE
		){
			if(GetActiveWindow() == NULL){
				m = 0;
				rectest = recting;
				EnumDesktopWindows(GetThreadDesktop(GetCurrentThreadId()), EnumWindowsProc, (LPARAM)&m);
				o = m;
				i = rectest.right-rectest.left;
				j = rectest.bottom-rectest.top;
				SystemParametersInfo(SPI_GETWORKAREA, 0, &recter, 0);
				if(video){
					w = (double)(recting.right-recting.left-2*GetSystemMetrics(SM_CXSIZEFRAME)-GetSystemMetrics(SM_CXVSCROLL)) / (double)videw;
					h = (double)((recting.bottom-recting.top-2*GetSystemMetrics(SM_CYSIZEFRAME)-GetSystemMetrics(SM_CYCAPTION))-3*fontsize) / (double)videh;
					if(w > h){
						omasix = (int)(h*(double)videw+0.5);
						omasiy = (recting.bottom-recting.top-2*GetSystemMetrics(SM_CYSIZEFRAME)-GetSystemMetrics(SM_CYCAPTION))-3*fontsize;
					}else{
						omasix = (recting.right-recting.left-2*GetSystemMetrics(SM_CXSIZEFRAME)-GetSystemMetrics(SM_CXVSCROLL));
						omasiy = (int)(w*(double)videh+0.5);
					}
					omasix = (recting.right-recting.left-2*GetSystemMetrics(SM_CXSIZEFRAME)-GetSystemMetrics(SM_CXVSCROLL)) - omasix;
					omasiy = (recting.bottom-recting.top-2*GetSystemMetrics(SM_CYSIZEFRAME)-GetSystemMetrics(SM_CYCAPTION))-3*fontsize - omasiy;
				}else{
					omasix = omasiy = 0;
				}
				if(m > i*j){
					if((n=rand()%3)%2 == 0) switch(rand()%2){
					case 0:
						k = (rand()%100) * ((recter.right - recter.left - i)/10) / 99;
						if(k < 3) k = 3;
						if(rectest.left-recter.left < recter.right-rectest.right){
							rectest.left = recter.left + (rectest.left-recter.left>k/2?rectest.left-recter.left-k/2:0) + rand()%k;
						}else{
							rectest.left = recter.left + (recter.right-rectest.right>k/2?rectest.left-recter.left-k/2:recter.right-k-i+1) + rand()%k;
						}
						break;
					case 1:
						k = (rand()%4) * (recter.right - recter.left - i) / 3;
						if(k < 3) k = 3;
						rectest.left = recter.left + (rand()%2?0:recter.right-k-i+1) + rand()%k;
						break;
					}
					if(n < 2) switch(rand()%2){
					case 0:
						k = (rand()%100) * ((recter.bottom - recter.top - j)/10) / 99;
						if(k < 3) k = 3;
						if(rectest.top-recter.top < recter.bottom-rectest.bottom){
							rectest.top = recter.top + (rectest.top-recter.top>k/2?rectest.top-recter.top-k/2:0) + rand()%k;
						}else{
							rectest.top = recter.top + (recter.bottom-rectest.bottom>k/2?rectest.top-recter.top-k/2:recter.bottom-k-j+1) + rand()%k;
						}
						break;
					case 1:
						k = (rand()%4) * (recter.bottom - recter.top - j) / 3;
						if(k < 3) k = 3;
						rectest.top = recter.top + (rand()%2?0:recter.bottom-k-j+1) + rand()%k;
						break;
					}
					if(101*i*j/100 < m && m < 2*i*j && rand()%2){
						if(omasix + omasiy > 0){
							rectest.left += (omasix+rand()%2)/2;
							i -= omasix;
							rectest.top += (omasiy+rand()%2)/2;
							j -= omasiy;
						}else switch(rand()%2){
						case 0:
							iiiii = (m-i*j+10*j-1)/(10*j);
							rectest.left += rand()%(iiiii+1);
							i -= iiiii;
							break;
						case 1:
							iiiii = (m-i*j+10*i-1)/(10*i);
							rectest.top += rand()%(iiiii+1);
							j -= iiiii;
							break;
						}
					}
					if(i > recter.right - recter.left) i = recter.right - recter.left;
					if(j > recter.bottom - recter.top) j = recter.bottom - recter.top;
					rectest.right = rectest.left + i;
					rectest.bottom = rectest.top + j;
					o = 0;
					EnumDesktopWindows(GetThreadDesktop(GetCurrentThreadId()), EnumWindowsProc, (LPARAM)&o);
				}else if(k = orectn.right-orectn.left, l = orectn.bottom-orectn.top, k > i || l > j){
					if(omasix + omasiy > 0){
						if(omasiy > 0){
							n = 0;
						}else{
							n = 1;
						}
					}else{
						n=rand()%2;
					}
					while(true){
						switch(n){
						case 0:
							if(k > i){
								iiiii = (k*l-i*j)/(10*l);
								if(iiiii <= 0) iiiii = 1;
								i += iiiii;
								iiiii = (iiiii<rectest.left-recter.left ? iiiii : rectest.left-recter.left);
								iiiiiii = (rectest.left+i>recter.right?rectest.left+i-recter.right:0);
								if(iiiii < iiiiiii) iiiii = iiiiiii;
								rectest.left -= rand()%(iiiii-iiiiiii+1) + iiiiiii;
								if(rectest.left < recter.left) rectest.left = recter.left;
								n = -1;
							}
							break;
						case 1:
							if(l > j){
								iiiii = (k*l-i*j)/(10*k);
								if(iiiii <= 0) iiiii = 1;
								j += iiiii;
								iiiii = (iiiii<rectest.top-recter.top ? iiiii : rectest.top-recter.top);
								iiiiiii = (rectest.top+j>recter.bottom?rectest.top+j-recter.bottom:0);
								if(iiiii < iiiiiii) iiiii = iiiiiii;
								rectest.top -= rand()%(iiiii-iiiiiii+1) + iiiiiii;
								if(rectest.top < recter.top) rectest.top = recter.top;
								n = -1;
							}
							break;
						default:
							n = -1;
						}
						if(n < 0) break;
						n = (n+1)%2;
					}
					if(i > recter.right - recter.left) i = recter.right - recter.left;
					if(j > recter.bottom - recter.top) j = recter.bottom - recter.top;
					rectest.right = rectest.left + i;
					rectest.bottom = rectest.top + j;
					o = -1;
				}
				if(o < m){
					recting = rectest;
					mout = 0;
				}
				GetWindowRect(hwnd, &recnar);
				if(mout < motime){
					mout++;
					MoveWindow(hwnd,
						recnar.left+mout*(recting.left-recnar.left)/motime,
						recnar.top+mout*(recting.top-recnar.top)/motime,
						recnar.right-recnar.left+mout*(recting.right-recting.left-recnar.right+recnar.left)/motime,
						recnar.bottom-recnar.top+mout*(recting.bottom-recting.top-recnar.bottom+recnar.top)/motime,
						TRUE);
				}else{
					recting = recnar;
					mout = 0;
				}
			}else{
				GetWindowRect(hwnd, &recting);
			}
		}
		return 0;

	case WM_SYSKEYDOWN:
		if(wParam == VK_RETURN){
			if(video){
				pVideoWindow->get_FullScreenMode(&eventCode);
				if(eventCode != OAFALSE) pVideoWindow->put_FullScreenMode(OAFALSE);
				else pVideoWindow->put_FullScreenMode(OATRUE);
			}
			return 0;
		}
		break;

	case WM_RBUTTONUP:
		omcisak = !omcisak;
		orectn.right += (omcisak ? -1 : 1)*2*((videw>280?videw:280)/3);
		orectn.bottom += (omcisak ? -1 : 1)*2*(videh/3);
		break;

	case WM_VSCROLL:
		switch(LOWORD(wParam)){
		case SB_LINEUP:
			lll -= 1./60.;
			pMediaPosition->put_CurrentPosition(lll);
			break;
		case SB_LINEDOWN:
			lll += 1./60.;
			pMediaPosition->put_CurrentPosition(lll);
			break;
		case SB_PAGEUP:
			lll -= 5.;
			pMediaPosition->put_CurrentPosition(lll);
			break;
		case SB_PAGEDOWN:
			lll += 5.;
			pMediaPosition->put_CurrentPosition(lll);
			break;
		case SB_THUMBPOSITION:
			pMediaPosition->put_CurrentPosition(length*HIWORD(wParam)/USHRT_MAX);
			break;
		}
		return 0;

	case WM_SIZE:
		ReSiZer(LOWORD(lParam), HIWORD(lParam));
		return 0 ;

	case WM_COMMAND:
		if((HWND)lParam == hwndButton){
			play = !play;
			if(play){
				pMediaControl->Run();
				SetWindowText(hwndButton, _T("a"));
			}else{
				pMediaControl->Pause();
				SetWindowText(hwndButton, _T(""));
			}
			return 0;
		}
		break;

	case WM_USER:
		while(SUCCEEDED(pMediaEventEx->GetEvent(&eventCode, &p1, &p2, 0))){
			switch(eventCode){
			case EC_COMPLETE:
			case EC_USERABORT:
				PostMessage(hwnd, WM_CLOSE, 0, 0);
				break;
			}
			pMediaEventEx->FreeEventParams(eventCode, p1, p2);
		}
		return 0;

	case WM_DESTROY : // I

		KillTimer(hwnd, 1);

		if(pVideoWindow) pVideoWindow->put_Visible(OAFALSE);
		if(pVideoWindow) pVideoWindow->put_Owner(NULL);
		if(pBasicAudio) pBasicAudio->Release();
		if(pBasicVideo) pBasicVideo->Release();
		if(pGargle) pGargle->Release();
		if(pMediaPosition) pMediaPosition->Release();
		if(pMediaEventEx) pMediaEventEx->Release();
		if(pMediaControl) pMediaControl->Release();
		if(pVideoWindow) pVideoWindow->Release();
		if(pGraphBuilder) pGraphBuilder->Release();
		CoUninitialize();

		DeleteObject(hFont);
		DeleteObject(hMuFont);

		PostQuitMessage(0);

		return 0;

	}

	return DefWindowProc(hwnd,iMsg,wParam,lParam);

}

